import { AstNode } from "./core/AstNode";
export class BaseInvocation extends AstNode {
    reference;
    arguments;
    constructor({ reference, arguments_ }) {
        super();
        this.reference = reference;
        this.arguments = arguments_;
        this.inheritReferences(reference);
        this.arguments.forEach((arg) => {
            this.inheritReferences(arg);
        });
    }
    write(writer) {
        this.reference.write(writer);
        writer.write("(");
        this.arguments.forEach((arg, idx) => {
            arg.write(writer);
            if (idx < this.arguments.length - 1) {
                writer.write(", ");
            }
        });
        writer.write(")");
    }
}
