import { Reference } from "./Reference";
import { AstNode } from "./core/AstNode";
import { Writer } from "./core/Writer";
import { Decorator } from "./Decorator";
import { Field } from "./Field";
export declare namespace Class {
    interface Args {
        name: string;
        docs?: string;
        extends_?: Reference[];
        decorators?: Decorator[];
    }
}
export declare class Class extends AstNode {
    readonly name: string;
    readonly extends_: Reference[];
    readonly decorators: Decorator[];
    readonly fields: Field[];
    readonly docs?: string;
    private statements;
    constructor({ docs, name, extends_, decorators }: Class.Args);
    write(writer: Writer): void;
    add(statement: AstNode): void;
    private writeStatements;
    addField(field: Field): void;
}
