import { AstNode } from "./core/AstNode";
import { Writer } from "./core/Writer";
import { Type } from "./Type";
export declare namespace Field {
    interface BaseArgs {
        name: string;
        docs?: string;
    }
    type Args = BaseArgs & ({
        type: Type;
        initializer?: AstNode;
    } | {
        type?: Type;
        initializer: AstNode;
    } | {
        type: Type;
        initializer: AstNode;
    });
}
export declare class Field extends AstNode {
    readonly name: string;
    readonly type: Type | undefined;
    readonly initializer: AstNode | undefined;
    readonly docs: string | undefined;
    constructor({ name, type, initializer, docs }: Field.Args);
    write(writer: Writer): void;
}
