import { AstNode } from "./core/AstNode";
export class Field extends AstNode {
    name;
    type;
    initializer;
    docs;
    constructor({ name, type, initializer, docs }) {
        super();
        this.name = name;
        this.type = type;
        this.initializer = initializer;
        this.docs = docs;
        this.inheritReferences(this.type);
        this.inheritReferences(this.initializer);
    }
    write(writer) {
        writer.write(this.name);
        if (this.type !== undefined) {
            writer.write(": ");
            this.type.write(writer);
        }
        if (this.initializer !== undefined) {
            writer.write(" = ");
            this.initializer.write(writer);
        }
        if (this.docs != null) {
            writer.newLine();
            writer.write('"""');
            writer.newLine();
            writer.write(this.docs);
            writer.newLine();
            writer.write('"""');
        }
    }
}
