import { AstNode } from "./core/AstNode";
import { Writer } from "./core/Writer";
import { Type } from "./Type";
import { Parameter } from "./Parameter";
import { Decorator } from "./Decorator";
export declare enum ClassMethodType {
    STATIC = 0,
    INSTANCE = 1,
    CLASS = 2
}
export declare namespace Method {
    interface Args {
        name: string;
        parameters?: Parameter[];
        return_?: Type;
        docstring?: string;
        type?: ClassMethodType;
        static_?: boolean;
        decorators?: Decorator[];
    }
}
export declare class Method extends AstNode {
    readonly name: string;
    readonly return: Type | undefined;
    readonly docstring: string | undefined;
    readonly type: ClassMethodType | undefined;
    private readonly parameters;
    private readonly decorators;
    private readonly statements;
    private readonly static_;
    constructor({ static_, name, parameters, return_, docstring, type, decorators }: Method.Args);
    addStatement(statement: AstNode): void;
    write(writer: Writer): void;
}
