import { AstNode } from "./core/AstNode";
import { Writer } from "./core/Writer";
import { OperatorType } from "./OperatorType";
export declare namespace Operator {
    interface Args {
        operator: OperatorType;
        lhs: AstNode;
        rhs: AstNode;
    }
}
export declare class Operator extends AstNode {
    private readonly operator;
    private readonly lhs;
    private readonly rhs;
    constructor({ operator, lhs, rhs }: Operator.Args);
    private getOperatorString;
    write(writer: Writer): void;
}
