import { CodeBlock } from "./CodeBlock";
import { AstNode } from "./core/AstNode";
import { Writer } from "./core/Writer";
import { Type } from "./Type";
export declare namespace Parameter {
    interface Args {
        name: string;
        type: Type;
        initializer?: CodeBlock;
    }
}
export declare class Parameter extends AstNode {
    readonly name: string;
    readonly initializer: CodeBlock | undefined;
    readonly type: Type;
    constructor({ name, type, initializer }: Parameter.Args);
    write(writer: Writer): void;
}
