import { AstNode } from "./core/AstNode";
export class Parameter extends AstNode {
    name;
    initializer;
    type;
    constructor({ name, type, initializer }) {
        super();
        this.name = name;
        this.type = type;
        this.initializer = initializer;
    }
    write(writer) {
        writer.write(this.name);
        writer.write(": ");
        this.type.write(writer);
        if (this.initializer !== undefined) {
            writer.write(" = ");
            this.initializer.write(writer);
        }
    }
}
