import { AstNode } from "./core/AstNode";
import { Comment } from "./Comment";
import { Writer } from "./core/Writer";
import { ModulePath } from "./core/types";
import { StarImport } from "./StarImport";
export declare namespace PythonFile {
    interface Args {
        path: ModulePath;
        statements?: AstNode[];
        isInitFile?: boolean;
        comments?: Comment[];
        imports?: StarImport[];
    }
}
export declare class PythonFile extends AstNode {
    readonly path: ModulePath;
    readonly isInitFile: boolean;
    private readonly statements;
    private readonly comments;
    constructor({ path, statements, isInitFile, comments, imports }: PythonFile.Args);
    addStatement(statement: AstNode): void;
    write(writer: Writer): void;
    /*******************************
     * Helper Methods
     *******************************/
    private updateWriterRefNameOverrides;
    private getInitialUsedNames;
    private deduplicateReferences;
    private writeComments;
    private getImportName;
    private writeImports;
}
