import { AstNode } from "./core/AstNode";
import { AttrPath, ModulePath } from "./core/types";
import { Writer } from "./core/Writer";
export declare namespace Reference {
    interface Args {
        name: string;
        modulePath?: ModulePath;
        genericTypes?: AstNode[];
        alias?: string;
        attribute?: AttrPath;
    }
}
export declare class Reference extends AstNode {
    readonly name: string;
    readonly modulePath: ModulePath;
    readonly genericTypes: AstNode[];
    readonly alias: string | undefined;
    readonly attribute: AttrPath;
    constructor({ name, modulePath, genericTypes, alias, attribute }: Reference.Args);
    write(writer: Writer): void;
    getFullyQualifiedPath(): string;
    getFullyQualifiedModulePath(): string;
}
