import { AstNode } from "./core/AstNode";
import { Writer } from "./core/Writer";
import { Reference } from "./Reference";
export declare class Type extends AstNode {
    private internalType;
    private constructor();
    static int(): Type;
    static float(): Type;
    static bool(): Type;
    static str(): Type;
    static bytes(): Type;
    static list(value: Type): Type;
    static set(value: Type): Type;
    static tuple(values: Type[]): Type;
    static dict(keyType: Type, valueType: Type): Type;
    static none(): Type;
    static uuid(): Type;
    static optional(value: Type): Type;
    static union(values: Type[]): Type;
    static any(): Type;
    static datetime(): Type;
    static reference(value: Reference): Type;
    static literal(value: string | boolean | number): Type;
    write(writer: Writer): void;
}
