import { AstNode } from "./core/AstNode";
import { Writer } from "./core/Writer";
import { Type } from "./Type";
interface DictEntry {
    key: AstNode;
    value: AstNode;
}
export declare class TypeInstantiation extends AstNode {
    private readonly internalType;
    private constructor();
    static int(value: number): TypeInstantiation;
    static float(value: number): TypeInstantiation;
    static bool(value: boolean): TypeInstantiation;
    static str(value: string, config?: {
        multiline: boolean;
    }): TypeInstantiation;
    static bytes(value: string): TypeInstantiation;
    static list(values: AstNode[]): TypeInstantiation;
    static set(values: AstNode[]): TypeInstantiation;
    static tuple(values: AstNode[]): TypeInstantiation;
    static dict(entries: DictEntry[]): TypeInstantiation;
    static none(): TypeInstantiation;
    static uuid(value: string): TypeInstantiation;
    write(writer: Writer): void;
    private writeStringWithTripleQuotes;
    private escapeString;
}
export { Type };
