import { AbstractAstNode } from "@fern-api/base-generator";
import { Writer } from "./Writer";
export class AstNode extends AbstractAstNode {
    references = [];
    addReference(reference) {
        this.references.push(reference);
    }
    inheritReferences(astNode) {
        if (astNode === undefined) {
            return;
        }
        astNode.references.forEach((reference) => {
            if (!this.references.includes(reference)) {
                this.addReference(reference);
            }
        });
    }
    getReferences() {
        return this.references;
    }
    /**
     * Writes the node to a string.
     */
    toString() {
        const writer = new Writer();
        this.write(writer);
        return writer.toString();
    }
    /**
     * Writes the node to a string and formats it.
     */
    async toStringFormatted(config) {
        const writer = new Writer();
        this.write(writer);
        return await writer.toStringFormatted(config);
    }
}
