import { AbstractWriter } from "@fern-api/base-generator";
export class Writer extends AbstractWriter {
    fullyQualifiedModulePathsToImportedNames = {};
    setRefNameOverrides(completeRefPathsToNameOverrides) {
        this.fullyQualifiedModulePathsToImportedNames = completeRefPathsToNameOverrides;
    }
    unsetRefNameOverrides() {
        this.fullyQualifiedModulePathsToImportedNames = {};
    }
    getRefNameOverride(reference) {
        const explicitNameOverride = this.fullyQualifiedModulePathsToImportedNames[reference.getFullyQualifiedModulePath()];
        if (explicitNameOverride) {
            return explicitNameOverride;
        }
        return { name: reference.alias ?? reference.name, isAlias: !!reference.alias };
    }
    toString() {
        return this.buffer;
    }
    async toStringFormatted(config) {
        const { default: init, format } = await import("@wasm-fmt/ruff_fmt");
        await init();
        return format(this.buffer, undefined, config);
    }
}
